//     :     :     :     :     :     :     :     :     :     :
//   --------:  ---------:  ---------:  ---------:  ----     :
// ..|      |*..|       |*..|       |*..|       |*..|  |*....:.
//   |      |*  |       |*  |       |*  |       |*  |  |*    :
//   ---  ---*  |  |-----*  |  |-----*  |  |-----*  |  |*    :
// ....|  |*.:..|  |--****..|  |-----*..|  |--****..|  |*....:.
//     |  |* :  |    |*  :  |  |--  |*  |    |*  :  |  |*    :
//     |  |* :  |  |--*  :  |  |*|  |*  |  |--*  :  |  |*    :
// ....|  |*.:..|  |-----:..|  ---  |*..|  |-----:..|  -----.:.
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
// ....----*.:..---------*..---------*..---------*..--------*:.
//     :**** :   *********   *********   *********   ********:
//     :     :     :     :     :     :     :     :     :     :
//
// Version 0.81
// Copyright (c) 2002-2007
// Martijn "Amarillion" van Iersel.
//
// This file is part of the Tegel tilemapping add-on for allegro
//
//    Tegel is free software; you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General 
//    Public License as published by the Free Software 
//    Foundation; either version 2.1 of the License, or
//    (at your option) any later version.
//
//    Tegel is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with Tegel; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
// official website:
// http://tegel.sourceforge.net/
//
// I hope you like this program. Please send 
// questions, comments, flames and feature 
// requests to amarillion@yahoo.com.
//
#include "gridbox.h"
#include <string>

using namespace MAS;

GridBox::GridBox(void) 
    :MyScrollBox(),       
    rowHeight (32),
    colWidth (32),
    rowNum (1),
    colNum (1),
    showGrid (true)
{
}

void GridBox::DrawCell (Bitmap &dest, int col, int row, int x, int y)
{
}


void GridBox::DrawClientArea (Bitmap &dest, int xofst, int yofst)
{   
    // only draw cliprect part
	//~ Rect clip = dest.GetClip();
	
	// now start drawing those cells
    int ix, iy;
    int irow, icol;
    if (rowHeight != 0 && colWidth != 0) 
        for (iy = - (yofst % rowHeight), irow = yofst / rowHeight; 
         iy < dest.h() && irow < rowNum; 
         iy += rowHeight, ++irow)
    {    
        for (ix = - (xofst % colWidth), icol = xofst / colWidth; 
             ix < dest.w() && icol < colNum; 
             ix += colWidth, ++icol)
        {
            DrawCell (dest, icol, irow, ix, iy);
        }           
    }
	//~ clip.w(clip.w() - 1);
	//~ clip.h(clip.h() - 1);
	//~ dest.Rectangle (clip, Color::red);
}

void GridBox::SetColWidth (int value)
{
    colWidth = value;
    SetScrollSize (colWidth * colNum, rowHeight * rowNum);
}

void GridBox::SetRowHeight (int value)
{
    rowHeight = value;
    SetScrollSize (colWidth * colNum, rowHeight * rowNum);
}

void GridBox::SetRowNum (int value)
{
    rowNum = value;
    SetScrollSize (colWidth * colNum, rowHeight * rowNum);
}

void GridBox::SetColNum (int value)
{
    colNum = value;
    SetScrollSize (colWidth * colNum, rowHeight * rowNum);
}

int GridBox::GetCol (int _x)
{
    int xoffset = GetXOffset();
    return (_x + xoffset) / colWidth; 
}

int GridBox::GetRow (int _y)
{
    int yoffset = GetYOffset();
    return (_y + yoffset) / rowHeight;
}
