//     :     :     :     :     :     :     :     :     :     :
//   --------:  ---------:  ---------:  ---------:  ----     :
// ..|      |*..|       |*..|       |*..|       |*..|  |*....:.
//   |      |*  |       |*  |       |*  |       |*  |  |*    :
//   ---  ---*  |  |-----*  |  |-----*  |  |-----*  |  |*    :
// ....|  |*.:..|  |--****..|  |-----*..|  |--****..|  |*....:.
//     |  |* :  |    |*  :  |  |--  |*  |    |*  :  |  |*    :
//     |  |* :  |  |--*  :  |  |*|  |*  |  |--*  :  |  |*    :
// ....|  |*.:..|  |-----:..|  ---  |*..|  |-----:..|  -----.:.
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
// ....----*.:..---------*..---------*..---------*..--------*:.
//     :**** :   *********   *********   *********   ********:
//     :     :     :     :     :     :     :     :     :     :
//
// Version 0.81
// Copyright (c) 2002-2007
// Martijn "Amarillion" van Iersel.
//
// This file is part of the Tegel tilemapping add-on for allegro
//
//    Tegel is free software; you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General 
//    Public License as published by the Free Software 
//    Foundation; either version 2.1 of the License, or
//    (at your option) any later version.
//
//    Tegel is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with Tegel; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
// official website:
// http://tegel.sourceforge.net/
//
// I hope you like this program. Please send 
// questions, comments, flames and feature 
// requests to amarillion@yahoo.com.
//
#include "sizdlg.h"

SizeDlg::SizeDlg() : Window ()    
{
    Resize (320, 240);
    Centre();
    b1.Setup (62, 128, 81, 24, KEY_ENTER, D_EXIT, "&OK");
    b2.Setup (158, 128, 81, 24, KEY_ESC, D_EXIT, "&Cancel");
    t1.SetText ("Width");
    t1.Shape (32, 32, 100, 16);    
    t2.SetText ("Height");
    t2.Shape (32, 64, 100, 16);
    t3.SetText ("Number of Layers");
    t3.Shape (32, 96, 100, 16);
    e1.Setup (172, 32, 100, 16, 0, 0, "", 3);
    e2.Setup (172,64,100,16, 0, 0, "", 3);
    e3.Setup (172,96,100,16, 0, 0, "", 3);
    Add (e1);
    Add (e2);
    Add (e3);
    Add (t1);
    Add (t2);
    Add (t3);
    Add (b1);
    Add (b2);   
}

SizeDlg::~SizeDlg()
{
}

bool SizeDlg::getMapSize (Dialog *parent, int &w, int &h, int &dl)
{
    SizeDlg dlg;
    dlg.e1.SetNumber(w);
    dlg.e2.SetNumber(h);
    dlg.e3.SetNumber(dl);
    if (dlg.Popup (parent) == &dlg.b1)
    {
        w = dlg.e1.GetInt();
        h = dlg.e2.GetInt();
        dl = dlg.e3.GetInt();
        return true;
    } 
    return false;
}
 
