//     :     :     :     :     :     :     :     :     :     :
//   --------:  ---------:  ---------:  ---------:  ----     :
// ..|      |*..|       |*..|       |*..|       |*..|  |*....:.
//   |      |*  |       |*  |       |*  |       |*  |  |*    :
//   ---  ---*  |  |-----*  |  |-----*  |  |-----*  |  |*    :
// ....|  |*.:..|  |--****..|  |-----*..|  |--****..|  |*....:.
//     |  |* :  |    |*  :  |  |--  |*  |    |*  :  |  |*    :
//     |  |* :  |  |--*  :  |  |*|  |*  |  |--*  :  |  |*    :
// ....|  |*.:..|  |-----:..|  ---  |*..|  |-----:..|  -----.:.
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
//     |  |* :  |       |*  |       |*  |       |*  |      |*:
// ....----*.:..---------*..---------*..---------*..--------*:.
//     :**** :   *********   *********   *********   ********:
//     :     :     :     :     :     :     :     :     :     :
//
// Version 0.81
// Copyright (c) 2002-2007
// Martijn "Amarillion" van Iersel.
//
// This file is part of the Tegel tilemapping add-on for allegro
//
//    Tegel is free software; you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General 
//    Public License as published by the Free Software 
//    Foundation; either version 2.1 of the License, or
//    (at your option) any later version.
//
//    Tegel is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with Tegel; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	
// official website:
// http://tegel.sourceforge.net/
//
// I hope you like this program. Please send 
// questions, comments, flames and feature 
// requests to amarillion@yahoo.com.
//
#include "tegel.h"
#include <allegro.h>
#include <stdio.h>
#include <string.h>

void dat_rle2bmp (DATAFILE *data)
{
    DATAFILE *d = data;
    while (d->type != DAT_END)
    {
        dat_object_rle2bmp (d);
        d++;
    }
}

void dat_object_rle2bmp (DATAFILE *data)
{
    if (data->type == DAT_RLE_SPRITE)
    {
        RLE_SPRITE *s = (RLE_SPRITE*)data->dat;
        BITMAP *b = create_bitmap (s->w, s->h);
        clear (b);
        draw_rle_sprite (b, s, 0, 0);
        destroy_rle_sprite (s);
        data->dat = b;
        data->type = DAT_BITMAP;
    }
}

/* Returns Zero on failure, non-zero on success. */
int take_screen_shot( char *filename )
{
   BITMAP *vis; // visible screen
   PALETTE pal; // current palette
   int ret = -1;     // return value

   get_palette( pal );
   vis = create_sub_bitmap( screen, 0, 0, SCREEN_W, SCREEN_H );
   if( vis != NULL )
   {
      ret = save_bitmap( filename, vis, pal );
      destroy_bitmap( vis );
   }

   return ret == 0;
}

void screenshot()
{

    char filename[14];
    int count = 0;

    // search for a unused filename of the format ssNNNNNN.pcx
    do
    {
       sprintf( filename, "ss%06d.pcx", count++ );
    } while ( strlen(filename) == 12 && exists(filename) );
    
    if( strlen(filename) == 12 )
    {
       take_screen_shot(filename);
    }
    else
    {
       /* Error: All filenames taken */
    }

}

void tempClipRect (BITMAP *bmp, ClipRect *cr, int x, int y, int w, int h)
{
    (*cr)[0] = bmp->cl;
    (*cr)[1] = bmp->cr;
    (*cr)[2] = bmp->ct;
    (*cr)[3] = bmp->cb;
    set_clip (bmp, x, y, x + w - 1, y + h - 1);
}

void restoreClipRect (BITMAP *bmp, ClipRect *cr)
{
    bmp->cl = (*cr)[0];
    bmp->cr = (*cr)[1];
    bmp->ct = (*cr)[2];
    bmp->cb = (*cr)[3];
}

